commit 5d6afc601443fa5c03680fb7f39b7dc1f36766a8
Author: Richard Biener <rguenther@suse.de>
Date:   Tue Jun 25 16:13:02 2024 +0200

    tree-optimization/115646 - ICE with pow shrink-wrapping from bitfield
    
    The following makes analysis and transform agree on constraints.
    
            PR tree-optimization/115646
            * tree-call-cdce.cc (check_pow): Check for bit_sz values
            as allowed by transform.
    
            * gcc.dg/pr115646.c: New testcase.
    
    (cherry picked from commit 453b1d291d1a0f89087ad91cf6b1bed1ec68eff3)

diff --git a/gcc/testsuite/gcc.dg/pr115646.c b/gcc/testsuite/gcc.dg/pr115646.c
new file mode 100644
index 00000000000..7938a309513
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr115646.c
@@ -0,0 +1,14 @@
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+/* { dg-require-effective-target int32plus } */
+
+extern double pow(double x, double y);
+
+struct S {
+    unsigned int a : 3, b : 8, c : 21;
+};
+
+void foo (struct S *p)
+{
+  pow (p->c, 42);
+}
diff --git a/gcc/tree-call-cdce.cc b/gcc/tree-call-cdce.cc
index 83991fe373e..91878129835 100644
--- a/gcc/tree-call-cdce.cc
+++ b/gcc/tree-call-cdce.cc
@@ -260,7 +260,7 @@ check_pow (gcall *pow_call)
       /* If the type of the base is too wide,
          the resulting shrink wrapping condition
 	 will be too conservative.  */
-      if (bit_sz > MAX_BASE_INT_BIT_SIZE)
+      if (bit_sz != 8 && bit_sz != 16 && bit_sz != MAX_BASE_INT_BIT_SIZE)
         return false;
 
       return true;

